
;****************************
;*  Demo for PAN1 code V1.0 *
;****************************
; By Jeff Frohwein

; Last edit 17-Aug-97

        INCLUDE "hardware.inc"

;Version 1.2 or later of 'hardware.inc' is required.
        rev_Check_hardware_inc 1.5

        SECTION "Org $0",HOME
        ret

        DB      "Date 970817"           ; Date stamping info for
                                        ; reference use only
        SECTION "Org $100",HOME[$100]

;*** Beginning of rom execution point ***

        nop
        jp      begin

        NINTENDO_LOGO                   ; Nintendo graphic logo

;Rom Header Info

;    0123456789ABCDEF
 DB "PAN1 LIB DEMO",0,0,0     ; Cart name   16bytes
 DB 0,0,0                     ; Not used
 DB CART_ROM                  ; Cart type
 DB CART_ROM_256K             ; ROM Size (in bits)
 DB CART_RAM_NONE             ; RAM Size (in bits)
 DB 1,1                       ; Maker ID
 DB 0                         ; Version     =0
 DB $e2                       ; Complement check (important)
 DW $c40e                     ; Checksum (not important)

; Library Includes

        INCLUDE "keypad.asm"
        INCLUDE "memory1.asm"
        INCLUDE "pan1.asm"
        INCLUDE "u161632a.asm"
        INCLUDE "tilemap.asm"

;Version 1.2 or later of 'keypad.asm' is required.
        rev_Check_keypad_asm 1.2
;Version 1.0 or later of 'memory1.asm' is required.
        rev_Check_memory1_asm 1.0
;Version 1.7 or later of 'pan1.asm' is required.
        rev_Check_pan1_asm 1.7
;Version 1.1 or later of 'u161632a.asm' is required.
        rev_Check_u161632a_asm 1.1

        SECTION "Main Code",HOME
begin:
        di
                  ; The stack initializes to $FFFE

        ld      a,0
        ldh     [rIE],a         ;disable interrupts

; Must be in VBL before turning the screen off.
WaitVBL:
        ldh    a,[rLY]         ; $ff44=LCDC Y-Pos
        cp     $90             ; $90 and bigger = in VBL
        jr     c,WaitVBL       ; Loop until it is $90 or >

        ld     a,LCDCF_OFF
        ldh    [rLCDC],a        ; Turn screen off for memory copy

        ld      a,$e4
        ldh     [rBGP],a        ; Setup default background colors

        ld      hl,TileData+1
        ld      de,$8000
        ld      bc,$1000
        call    mem_Copy        ; Copy tile set to memory

        ld      hl,MapData
        xor     a
        call    pan_Init         ; Initialize map

        ld      de,96
        ld      hl,300
        call    pan_Absolute     ; Pan to section of map with Mario

        ld      a,LCDCF_ON|LCDCF_BG8000|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ8|LCDCF_OBJOFF
        ldh    [rLCDC],a         ; Turn screen on

; Read keypad and scroll screen if requested.

loop:
        call    pad_Read

        bit     PADB_UP,a
        jr      z,loop2
        call    pan_Up
        jr      loop5
loop2:  bit     PADB_DOWN,a
        jr      z,loop3
        call    pan_Down
        jr      loop5
loop3:  bit     PADB_LEFT,a
        jr      z,loop4
        call    pan_Left
        jr      loop5
loop4:  bit     PADB_RIGHT,a
        jr      z,loop
        call    pan_Right

; Delay between scrolls

loop5:  ld      de,$1000
loop6:  dec     de
        ld      a,d
        or      e
        jr      nz,loop6

        jp      loop

